; Version 1.3 - September 8th 2000.
;
; Original file, (Hash table Viewer,) created by Variant.
; Modifications and additional features, (the one's that changed it 
; from a viewer to an editor,) provided by MIMP (MIMP@technologist.com)
; 
; Please refer to the readme file for details. If you do not have one please
; download a new copy from: http://mimp.dhs.org/scripts/hte.zip

alias hedit {
  ; *** Main alias, this's what you run to open or restore the editor... ;)

  if ($dialog(hashtableeditor) == $null) dialog -dm hashtableeditor hashtableeditor
  else dialog -v hashtableeditor
}
dialog hashtableeditor {
  ; *** Dialog table
  title "Hashtable Editor 1.3"
  size -1 -1 510 281
  option pixels
  combo 1,11 10 378 100, sort drop size
  list 2,10 36 380 187, vsbar hsbar extsel sort size
  button "&Refresh all",3,400 10 100 20, default
  button "Refresh &item list",4,400 34 100 20
  button "&Add Item",5,400 64 100 20
  button "&Edit Item",6,400 88 100 20, disable
  button "&Delete Item",7,400 112 100 20, disable
  edit "",8,40 227 350 20, autohs, disable
  edit "",9,40 251 350 20, autohs, disable
  button "Make Table",10,400 142 100 20
  button "Free Table",11,400 166 100 20
  button "Save Table",12,400 196 100 20
  button "Load Table",13,400 220 100 20
  button "&Close",14,400 250 100 20,ok
  text "Item:",15,10 230 29 12
  text "Value:",16,10 254 29 12
}
on 1:dialog:hashtableeditor:*:*:{
  if ($devent == init) {
    ; *** Initialize

    hte.hashes
    hte.list
  }
  elseif ($devent == sclick) {
    if ($did == 1) {
      ; *** Select a new hash table to edit

      hte.list
    }
    if ($did == 2) {
      ; *** Select/unselect an item in the listbox

      if ($did($dname,2,0).sel == 1) {
        did -e $dname 6,7
        did -ra $dname 7 Delete Item
      }
      elseif ($did($dname,2,0).sel == 0) {
        did -b $dname 6,7
        did -ra $dname 7 Delete Item
      }
      else {
        did -era $dname 7 Delete Items
        did -b $dname 6
    } }
    if ($did == 3) {
      ; *** Refresh all

      hte.hashes
      hte.list
    }
    if ($did == 4) {
      ; *** Refresh items

      hte.list
    }
    if ($did == 5) {
      ; *** Add item

      if ($did($dname,5) == &Add Item) {
        did -ub $dname 2
        did -e $dname 8,9
        did -b $dname 1,3,4,5,6,7,10,11,12,13
        did -ra $dname 5 Confirm
        did -ra $dname 14 &Cancel
        did -f $dname 8
      }
      elseif ($did($dname,5) == Overwrite) {
        var %temp = $did($dname,8) = *
        var %temp2 = $did($dname,8) = $did($dname,9)
        did -o $dname 2 $didwm($dname,2,%temp) %temp2
        hadd $gettok($did($dname,1).seltext,1,32) $did($dname,8) $did($dname,9)
        did -ec $dname 2 $didwm($dname,2,%temp2)
        did -br $dname 8,9
        did -ra $dname 5 &Add Item
        did -ra $dname 14 &Close
        did -e $dname 1,3,4,5,6,7,10,11,12,13
      }
      else {
        hadd $gettok($did($dname,1).seltext,1,32) $did($dname,8) $did($dname,9)
        var %temp = $did($dname,8) = $did($dname,9)
        did -ae $dname 2 %temp
        did -ec $dname 2 $didwm($dname,2,%temp)
        did -br $dname 8,9
        did -ra $dname 5 &Add Item
        did -ra $dname 14 &Close
        did -e $dname 1,3,4,5,6,7,10,11,12,13
    } }
    if ($did == 6) {
      ; *** Edit item  

      if ($did($dname,6) == &Edit Item) {
        did -a $dname 8 $gettok($did($dname,2,1).seltext,1,32)
        did -fae $dname 9 $hget($gettok($did($dname,1),1,32),$gettok($did($dname,2,1).seltext,1,32))
        did -b $dname 1,2,3,4,5,7,10,11,12,13
        did -ra $dname 6 Confirm
        did -ra $dname 14 &Cancel
      }
      else {
        did -d $dname 2 $did($dname,2,1).sel
        hdel $gettok($did($dname,1).seltext,1,32) $did($dname,8)
        hadd $gettok($did($dname,1).seltext,1,32) $did($dname,8) $did($dname,9)
        did -ac $dname 2 $did($dname,8) = $did($dname,9)
        did -br $dname 8,9
        did -ra $dname 6 &Edit Item
        did -ra $dname 14 &Cancel
        did -e $dname 1,2,3,4,5,7,10,11,12,13
    } }
    if ($did == 7) {
      ; *** Delete item(s)

      if ($did($dname,7) == Confirm) {
        while ($did($dname,2,0).sel) {
          hdel $gettok($did($dname,1),1,32) $gettok($did($dname,2,1).seltext,1,32)
          did -d $dname 2 $did($dname,2,1).sel
        } 
        did -bra $dname 7 Delete item
        did -ra $dname 14 &Close
        did -e $dname 1,2,3,4,5,10,11,12,13
        did -bnr $dname 8,9
        did -a $dname 15 Item:
        did -a $dname 16 Value:
      }
      else {
        did -ra $dname 7 Confirm
        did -ra $dname 14 &Cancel
        did -r $dname 15,16
        did -mea $dname 8 Are you sure you want to delete $iif($did($dname,2,0).sel > 1,these [ $did($dname,2,0).sel ] items?,this item?)
        did -b $dname 1,2,3,4,5,6,10,11,12,13
    } }
    if ($did == 10) {
      ; *** Makes a new table
      if ($did($dname,10) == Make Table) {
        did -ra $dname 15 Name:
        did -ra $dname 16 Size:
        did -rab $dname 10 Confirm
        did -ra $dname 14 &Cancel
        did -e $dname 8,9
        did -b $dname 1,2,3,4,5,6,7,11,12,13
        did -u $dname 2
        did -f $dname 8
      }
      else {
        hmake $did($dname,8) $did($dname,9)
        hte.hashes
        var %temp = $did($dname,8) $+ *
        did -c $dname 1 $didwm($dname,1,%temp)
        hte.list
        did -ra $dname 15 Item:
        did -ra $dname 16 Value:
        did -rae $dname 10 Make Table
        did -ra $dname 14 &Close
        did -rb $dname 8,9
        did -e $dname 1,2,3,4,5,11,12,13
        did -b $dname 6,7
        did -r $dname 2
    } }
    if ($did == 11) {
      ; *** Frees the selected table
      if ($did($dname,11) == Free Table) {
        did -r $dname 15,16
        did -ra $dname 11 Confirm
        did -ra $dname 14 &Cancel
        did -b $dname 1,2,3,4,5,6,7,10,12,13
        did -u $dname 2
        did -mea $dname 8 Are you sure you wish to free the table named: $gettok($did($dname,1).seltext,1,32)
        did -mea $dname 9 Size: $left($gettok($did($dname,1).seltext,3,32),-1-) with $hget($gettok($did($dname,1).seltext,1,32),0).item items loaded.
      }
      else {
        hfree $gettok($did($dname,1).seltext,1,32)
        hte.hashes
        hte.list
        did -a $dname 15 Item:
        did -a $dname 16 Value:
        did -ra $dname 11 Free Table
        did -ra $dname 14 &Close
        did -e $dname 1,2,3,4,5,10,12,13
        did -nbr $dname 8,9
    } }
    if ($did == 12) {
      ; *** Save table

      if ($did($dname,12) == Save Table) {
        did -bra $dname 12 Confirm
        did -ra $dname 14 &Cancel
        did -b $dname 1,2,3,4,5,6,7,10,11,13
        did -mera $dname 8 Choose a filename:
        did -fe $dname 9
        did -r $dname 15
        did -ra $dname 16 File:
        did -u $dname 2
      }
      else {
        if ($did($dname,12) == Overwrite) hsave -o $gettok($did($dname,1).seltext,1,32) $did($dname,9)
        else hsave $gettok($did($dname,1).seltext,1,32) $did($dname,9)
        did -ra $dname 12 Save Table
        did -ra $dname 14 &Close
        did -ra $dname 15 Item:
        did -ra $dname 16 Value:
        did -e $dname 1,2,3,4,5,6,7,10,11,13
        did -nbra $dname 8,9
    } }
    if ($did == 13) {
      ; *** Load table (Append table when saving and name exists.)

      if ($did($dname,13) == Load Table) {
        did -ra $dname 13 Confirm
        did -ra $dname 14 &Cancel
        did -ra $dname 16 File:
        did -r $dname 15
        did -mera $dname 8 Please specify the file to load:
        did -fe $dname 9
        did -b $dname 1,2,3,4,5,6,7,10,11,12
        did -u $dname 2
      }
      elseif ($did($dname,13) == Append) {
        hsave -a $gettok($did($dname,1).seltext,1,32) $did($dname,9)
        did -ra $dname 12 Save Table
        did -ra $dname 13 Load Table
        did -ra $dname 14 &Close
        did -ra $dname 15 Item:
        did -ra $dname 16 Value:
        did -e $dname 1,2,3,4,5,6,7,10,11,13
        did -nbra $dname 8,9
      }
      elseif ($did($dname,8) == Please specify the file to load:) {
        did -ra $dname 8 What table name should this file use:
        did -ra $dname 16 Name:
        set %hash.table.editor.file $did($dname,9)
        did -fr $dname 9
        did -b $dname 13
      }
      else {
        hload $did($dname,9) %hash.table.editor.file
        unset %hash.table.editor.file
        did -ra $dname 13 Load table
        did -ra $dname 14 &Close
        did -ra $dname 15 Item:
        did -ra $dname 16 Value:
        hte.hashes
        var %temp = $did($dname,9) $+ *
        did -c $dname 1 $didwm($dname,1,%temp)
        hte.list
        did -nbra $dname 8,9
        did -e $dname 1,2,3,4,5,10,11,12
    } }
    if ($did == 14) {
      ; *** Close/cancel
      if ($did($dname,14) == &Cancel) {
        did -ra $dname 5 &Add Item
        did -ra $dname 6 &Edit Item
        did -ra $dname 10 Make Table
        did -ra $dname 11 Free Table
        did -ra $dname 12 Save Table
        did -ra $dname 13 Load Table
        did -ra $dname 14 &Close
        did -a $dname 15 Item:
        did -a $dname 16 Value:
        did -nbr $dname 8,9
        did -e $dname 1,2,3,4,5,10,11,12,13
        if ($did($dname,2,0).sel == 0) {
          did -e $dname 6
          did -bra $dname 7 Delete Item
        }
        elseif ($did($dname,2,0).sel == 1) {
          did -e $dname 6
          did -era $dname 7 Delete Item
        }
        else {
          did -b $dname 6
          did -era $dname 7 Delete Items
        }
        halt
      }
      unset %hash.table.editor.file
  } }
  elseif ($devent == edit) {
    if ($did == 8) {
      ; *** Modify the upper (item/name) edit box

      if ($did($dname,15) == Item:) {
        if ($hget($gettok($did($dname,1),1,32),$did($dname,8)) == $null) did -ra $dname 5 Confirm
        else did -ra $dname 5 Overwrite
      }
      if ($did($dname,8) != $null) && ($did($dname,9) != $null) did -e $dname 5
      else did -b $dname 5
    }
    if ($did == 9) {
      ; *** Modify the lower (value/size/filename) edit box

      if ($did($dname,15) == Item:) {
        if ($did($dname,5) == &Add Item) {
          if ($did($dname,9) == $null) did -b $dname 6
          else did -e $dname 6
        }
        else {
          if ($did($dname,8) != $null) && ($did($dname,9) != $null) did -e $dname 5
          else did -b $dname 5
      } }
      elseif ($did($dname,16) == Size:) {
        if (($did($dname,8) != $null) && ($did($dname,9) isnum) && ($did($dname,9) > 0)) did -e $dname 10
        else did -b $dname 10
      }
      elseif ($did($dname,8) == Please specify the file to load:) {
        if ($exists($did($dname,9))) did -e $dname 13
        else did -b $dname 13
      }
      elseif ($did($dname,8) == What table name should this file use:) {
        if ($hget($did($dname,9)) == $did($dname,9)) did -e $dname 13
        else did -b $dname 13
      }
      else {
        if ($did($dname,9) != $null) { 
          if ($exists($did($dname,9))) {
            did -era $dname 12 Overwrite
            did -era $dname 13 Append
          }
          else {
            did -era $dname 12 Confirm
            did -bra $dname 13 Load Table
        } }
        else {
          did -bra $dname 12 Confirm
          did -bra $dname 13 Load Table
} } } } } 
alias -l hte.hashes {
  ; *** Fills the combo with the list of hash table names

  did -b $dname 6,7
  did -r hashtableeditor 1
  var %counter = 1
  while (%counter <= $hget(0)) {
    did -a hashtableeditor 1 $hget(%counter) (Size: $hget(%counter).size $+ $chr(41)
    inc %counter
  } 
  did -c hashtableeditor 1 1
}
alias -l hte.list {
  ; *** Fills the listbox with items and values for the selected hash table name 

  did -b $dname 6,7
  tokenize 32 hashtableeditor $gettok($did(hashtableeditor,1,$did(hashtableeditor,1).sel),1,32)
  did -r $1 2
  var %counter = 1
  while (%counter <= $hget($2,0).item) {
    did -a $1 2 $hget($hget($2),%counter).item = $hget($hget($2),$hget($hget($2),%counter).item)
    inc %counter
} }
on *:start:{
  ; *** Clean up the one variable that could be left over.

  if (%hash.table.editor.file != $null) unset %hash.table.editor.file
}
on *:load:{
  ; *** Welcome message.

  linesep -a
  echo $colour(info text) -i2a Heya,
  echo $colour(info text) -i2a $str($chr(160),4) Thanks for giving this script a try, to use it just type: /hedit
  echo $colour(info text) -i2a If you find any bugs please report them, email: MIMP@technologist.com
  echo $colour(info text) -i2a $chr(160)
  echo $colour(info text) -i2a $str($chr(160),9) MIMP
  linesep -a
}
